//
// ESP8266 Wifi Modul - Webclient
// Datei: buch4_kap10_esp8266_webclient.ino

#include <SoftwareSerial.h>

#define SSID "MeineWiFiSSID"
#define WIFIPASS "Passwort"
#define DSTIP "IP Server"
#define DSTPORT 80
#define HOST "meineWebsite.com"
#define USER_AGENT "User-Agent: Mozilla/0.1 (esp8266; WifiClient)"

// SoftSerial-Objekt, RX und TX
SoftwareSerial DbgSerial(10, 11);

// Tempsensor
int SensorPin=0;
float valTemp;
float tempC;
 
 
void setup() 
{
  Serial.begin(115200);
  // Debug
  DbgSerial.begin(9600);
  DbgSerial.println("ESP8266 Start...");
  espInit();
}
 
void loop() 
{
  sendData();
  delay(10000);
}
 
void espInit() 
{
  // Reset
  Serial.println("AT+RST");
  delay(1000);
  if(Serial.find("ready")) 
  {
    DbgSerial.println("Module ready...");
  }
  else 
  {
    DbgSerial.println("No response...");
  }
  Serial.println("AT+CWMODE=1");
  delay(500);
  Serial.println("AT+CIPMUX=0");
  delay(500);
  // Anmelden an WiFi
  Serial.print("AT+CWJAP=\"");
  Serial.print(SSID);
  Serial.print("\",\"");
  Serial.print(WIFIPASS);
  Serial.println("\"");
  delay(3500);
}
 
void sendData()
{
  // Daten Sensor
  valTemp = analogRead(SensorPin);
  tempC = (5.0 * valTemp * 100.0)/1024;
  tempC=18.99;
  char tpl[] = "GET /tempmail.php?t=%s HTTP/1.1\r\nHost: %s\r\n%s\r\n\r\n";
  char databuf[256] = "";
  char temp[6];
  dtostrf(tempC, 2, 2, temp);
  sprintf(databuf, tpl, temp, HOST, USER_AGENT);
  int ix = 1;
  for (ix=0; ix<256; ix++) {
    if ( databuf[ix] == 0 ) {
      break;
    }
  }
  Serial.print("AT+CIPSTART=\"TCP\",\"");
  Serial.print(DSTIP);
  Serial.print("\",");
  Serial.println(DSTPORT);
  delay(500);
  Serial.print("AT+CIPSEND=");
  Serial.println(ix);
  Serial.println(databuf);
  delay(500);
}
 
 
