//
// XML Daten von OpenWeatherMap abfragen
// Datei: buch4_kap10_read_openweathermap.ino


#include <SPI.h>
#include <Ethernet.h>
#include <TextFinder.h>

byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xAD };
byte ip[] = { 10, 0, 1, 200 };
byte gateway[] = { 10, 0, 1, 1 };
byte subnet[] = { 255, 255, 255, 0 };

// Server OpenWeatherMap
IPAddress server(178,62,207,82);

EthernetClient client;
TextFinder  finder( client );  

char ort[50];
char luftfeuchte[30];
char temperatur[5];

void setup()
{
  // Start Ethernet-Verbindung
  Ethernet.begin(mac, ip);
  // Initialisierung serielle Schnittstelle
  Serial.begin(9600);
  Serial.println("Setup...");
}


void loop()
{
  if (client.connect(server, 80))
  {
    // Aufruf Wetter-API
    // http://api.openweathermap.org/data/2.5/weather?q=Zurich&appid=APIKEY&units=metric&mode=xml
    //
    Serial.println("Connect to OpenWeatherMap...");
    client.println("GET /data/2.5/weather?q=Zurich&appid=APIKEY&units=metric&mode=xml HTTP/1.0");
    client.println("HOST:api.openweathermap.org\n\n");
    client.println();
    Serial.println("Connected...");
  } 
  else
  {
    Serial.println(" connection failed");
  } 
 

  if (client.connected())
  {
    // Stadt abfragen
    if ( (finder.getString("name=\"", "\"><coord ",ort,50)!=0) )
    {
      Serial.print("Ort:  ");
      Serial.println(ort);
    }
    
    // Temperatur in Celsius lesen
    if ( (finder.getString("<temperature value=\"", "\"",temperatur,5)!=0) )
    {
     Serial.print("Temperatur:  ");
     Serial.println(temperatur);
    }
    else
    {
      Serial.print("Kein Feld mit Temperatur gefunden");
    }

   
    // Luftfeuchte abfragen
    if ( (finder.getString("<humidity value=\"", "\"",luftfeuchte,4)!=0) )
    {
     Serial.print("Luftfeuchte:  ");
     Serial.println(luftfeuchte);
    }
    else
    {
      Serial.print("Kein Feld mit Luftfeuchte gefunden");
    }
    
          
  // Ende XML-Abfragen
  }
  else
  {
    Serial.println("Disconnected"); 
  }
 
  client.stop();
  client.flush();
  // 1 Minute warten
  delay(60000); 
}
