//
// XML Daten einlesen
// Datei: buch4_kap10_readxml.ino
//
// Quelle:
// Bibliothek Textfinder


#include <SPI.h>
#include <Ethernet.h>
#include <TextFinder.h>

byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xAD };
byte ip[] = { 10, 0, 1, 101 };
byte gateway[] = { 10, 0, 1, 1 };
byte subnet[] = { 255, 255, 255, 0 };
byte server[] = {82,195,224,125 }; // arduino-praxis.ch

EthernetClient client;
TextFinder  finder( client );  

char titel[50];
char verlag[30];

void setup()
{
  // Start Ethernet-Verbindung
  Ethernet.begin(mac, ip);
  // Initialisierung serielle Schnittstelle
  Serial.begin(9600);
  Serial.println("Setup...");
}


void loop()
{
  if (client.connect(server, 80))
  {
    Serial.println("Connect to XML...");
    client.println("GET /arduinobuch/xml/arduinopraxis.xml HTTP/1.0");
    client.println("HOST:www.arduino-praxis.ch\n\n");
    client.println();
    Serial.println("Connected...");
  } 
  else
  {
    Serial.println(" connection failed");
  } 
  if (client.connected())
  {
    
    // Titel abfragen
    // Feld in XML: <titel></titel>
   if ( (finder.getString("<titel>", "</titel>",titel,50)!=0) )
   {
     Serial.print("Titel:  ");
     Serial.println(titel);
   }
   
   // Platz für weitere Abfragen innerhalb des XML-Dokumentes
      
  // Ende XML-Abfragen
  }
  
  else
  {
    Serial.println("Disconnected"); 
  }
  client.stop();
  client.flush();  
  delay(60000); // 1 Minute warten
}
