//
// Daten senden an ThingSpeak
// Datei: buch4_kap10_thingspeak_one_channel.ino


#include "ThingSpeak.h"
#include <SPI.h>
#include <Ethernet.h>

byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED};

EthernetClient client;

/*
  *****************************************************************************************
  **** Visit https://www.thingspeak.com to sign up for a free account and create
  **** a channel.  The video tutorial http://community.thingspeak.com/tutorials/thingspeak-channels/ 
  **** has more information. You need to change this to your channel, and your write API key
  **** IF YOU SHARE YOUR CODE WITH OTHERS, MAKE SURE YOU REMOVE YOUR WRITE API KEY!!
  *****************************************************************************************/
  
unsigned long myChannelNumber = 705828;
const char * myWriteAPIKey = "YOURAPIKEY";

// Wert des LDR
int valLDR=0;

void setup() 
{
  // Ethernt-Client
  Ethernet.begin(mac);
  // ThingSpeak
  ThingSpeak.begin(client);
}

void loop() 
{
  // Analoger Eingang A0 einlesen
  valLDR = analogRead(A0);

  // Lichtwert von LDR an Feld 2
  ThingSpeak.writeField(myChannelNumber, 2, valLDR, myWriteAPIKey);
  
  // Warten bis zur nächsten Messung
  delay(20000);
}
