//
// ESP8266Webclient
// Datei: buch4_kap4_esp8266_wificlient_basic.ino

#include <ESP8266WiFi.h>

const char* ssid     = "ssid";
const char* password = "DeinPasswort";

const char* host = "www.arduino-praxis.ch";

void setup() 
{
  Serial.begin(115200);
  delay(100);

  // Start WiFi-Verbindung
  Serial.println();
  Serial.println();
  Serial.print("Verbindung...");
  Serial.println(ssid);
  
  WiFi.begin(ssid, password);
  
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

  Serial.println("");
  Serial.println("WiFi connected");  
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
}

int value = 0;

void loop() 
{
  delay(5000);
  ++value;

  Serial.print("verbinden... ");
  Serial.println(host);
  
  // WiFiClient Klasse
  WiFiClient client;
  const int httpPort = 80;
  if (!client.connect(host, httpPort)) {
    Serial.println("Verbindung fehlgeschlagen");
    return;
  }
  
  // URL für Aufruf
  String url = "/buch4/esp8266test.htm";
    
  Serial.print("URL: ");
  Serial.println(url);
  
  // This will send the request to the server
  client.print(String("GET ") + url + " HTTP/1.1\r\n" +
               "Host: " + host + "\r\n" + 
               "Connection: close\r\n\r\n");
  delay(500);
  
  // Antwort von Server lesen und ausgeben
  while(client.available()){
    String line = client.readStringUntil('\r');
    Serial.print(line);
  }
  
  Serial.println();
  Serial.println("Verbindung beenden");
}
