// RF 433 Mhz Receiver (One-Way, simplex)
// Datei: buch2_kap4_rf433_empfaenger.ino

#include <VirtualWire.h>
#undef int
#undef abs
#undef double
#undef float
#undef round

int RxPin = 2;

void setup()
{
  // serielle Schnittstelle
  Serial.begin(9600);
  // Initialisierung
  vw_set_ptt_inverted(true);
  // Geschwindigkeit (Bits pro Sekunden)
  vw_setup(2000);
  vw_set_rx_pin(RxPin);
  // Start des Empfängers
  vw_rx_start();
}

void loop()
{
  // Buffer mit Empfangsdaten erstellen
  uint8_t buf[VW_MAX_MESSAGE_LEN];
  // maximale Bufferlänge
  uint8_t buflen = VW_MAX_MESSAGE_LEN;
  
  // Prüfen ob Daten empfangen
  if (vw_get_message(buf, &buflen)) 
  {
    int i;
    // falls Checksumme ok
    // Zeichen aus Buffer einzeln ausgeben
    for (i = 0; i < buflen; i++)
    {
      // Ausgabe von Zeichen auf seriellen Schnittstelle
      Serial.print(buf[i]);
    }
    // neue Zeile
    Serial.println("");
  }
}
