// 1-Wire-Bus mit Temperatursensoren DS1020
// Datei: buch4_kap5_1wire_ds1820.ino

#include <OneWire.h>
#include <DallasTemperature.h>


// 1-Wire-Bus an Pin 10
#define ONE_WIRE_BUS 10

// 1-Wire-Bus instanziieren
OneWire oneWire(ONE_WIRE_BUS);

// Instanziieren der Dallas-Sensoren
DallasTemperature sensors(&oneWire);

// Uebertragungsgeschwindigkeit
int datarate = 9600;


void setup()
{
  // Start serieller Port
  Serial.begin(datarate);

  // Start der Sensorübertragung
  sensors.begin();
  
  // Anzahl Sensoren angeben
  Serial.println("Sensoren suchen...");
  Serial.print(sensors.getDeviceCount(), DEC);
  Serial.println(" Sensoren");
  delay(2000);
}


void loop()
{ 
  // Temperaturen abfragen
  sensors.requestTemperatures();
    
  // Sensor 0
  float tempC1 = sensors.getTempCByIndex(0);
  // Anzeige Grad C
  Serial.print("Sensor 0: ");
  Serial.println(tempC1);
  
  // Sensor 1
  float tempC2 = sensors.getTempCByIndex(1);
  Serial.print("Sensor 1: ");
  Serial.println(tempC2);
  delay(4000);
}
