//
// Temperatursensor von Lego Mindstorms abfragen
// Datei: buch4_kap5_mindstorms_tempsensor.ino
//
// Hinweis: Adresse mit I2C-Scanner ermittelt

#include <Wire.h>

// Rechts-Shift, da nur 7 Bits verwendet werden
int sensorAddress = 0x98 >> 1;
byte msb;
byte lsb;
int temperature;

void setup()
{
  // Serielle Kommunikation
  Serial.begin(9600);
  // teilnehmen am I2C-Bus
  // keine Adresse, da Master
  Wire.begin(); 
}

void loop()
{
  // 2 Byte vom Slave anfordern
  Wire.requestFrom(sensorAddress,2); 
  // falls 2 Bytes vorhanden sind
  if (2 <= Wire.available())
  {
    // 1. Byte empfangen
    // entspricht höherwertigem Byte (MSB)
    msb = Wire.read();
    // 2. Byte empfangen
    // entspricht niederwertigem Byte (LSB)
    lsb = Wire.read();
    
    // MSB Byte speichern als 12-Bit-Wert
    temperature = ((msb) << 4);
    // LSB Byte hinzufügen
    temperature |= (lsb >> 4);
    Serial.print("Temperature: ");
    // Umrechnung der Temperatur mit Auflösung von 0.0625 Grad pro Bit
    // und Ausgabe auf seriellem Port
    Serial.println(temperature*0.0625);
    
  }
  // 2 Sekunden warten
  delay(2000);
}
