//
// Kompass mit Richtungsanzeige mit Kompass-Sensor HMC5883
// Datei: buch4_kap5_projekt_kompass.ino

#include <Wire.h>
#include <HMC5883L.h>

float winkel;
int w;

// Pindefinitionen
#define LED1 2
#define LED2 3
#define LED3 4
#define LED4 5
#define LED5 6
#define LED6 7
#define LED7 8
#define LED8 9

// Kompass Objekt
HMC5883L compass;
// Fehler
int error = 0;

  
void setup()
{
  // Ausgänge setzen
  pinMode(LED1, OUTPUT);
  pinMode(LED2, OUTPUT);
  pinMode(LED3, OUTPUT);
  pinMode(LED4, OUTPUT);
  pinMode(LED5, OUTPUT);
  pinMode(LED6, OUTPUT);
  pinMode(LED7, OUTPUT);
  pinMode(LED8, OUTPUT);
  
  // Serielle Schnittstellen
  Serial.begin(9600);
  Wire.begin();
  Serial.print("Start Kompass mit HMC5883");

  // Skalierung setzen
  error = compass.SetScale(1.3);
  // falls Fehler
  if(error != 0){
    Serial.println(compass.GetErrorText(error));    
  }
  // Continuous Mode setzen
  error = compass.SetMeasurementMode(Measurement_Continuous);
  if(error != 0){
     Serial.println(compass.GetErrorText(error));
  }
}


void loop() 
{ 
  // Rohdaten einlesen
  MagnetometerRaw raw = compass.ReadRawAxis();
  // Skalierte Daten
  MagnetometerScaled scaled = compass.ReadScaledAxis();
  // Kalkulation
  float heading = atan2(scaled.YAxis, scaled.XAxis);
  
  // Ermittlung Magnetic Declination unter http://www.magnetic-declination.com/
  // Mein Wert: +2° 29' -> 2.48333° -> Rad 0.043342
  float declinationAngle = 0.043342;
  heading += declinationAngle;
  
  // Korrektur wenn invertiert
  if(heading < 0)
    heading += 2*PI;
  // Limitierung Winkel
  if(heading > 2*PI)
    heading -= 2*PI;
   
  // Umrechnung Radiant zu Grad
  winkel = heading * 180/M_PI;
  
  // Winkel als Integer
  w = winkel;
  
  // Ausgabe des Winkels Aktivierung der zugehörigen LED
  
  // D1, 337.5 - 360, 0-22.5
  if (w > 337.5 &&  w < 361)
  {
    digitalWrite(LED1, HIGH);
  }
  else
  {
    digitalWrite(LED1, LOW);
  }
  if (w > 0 &&  w < 22.5)
  {
    digitalWrite(LED1, HIGH);
  }
   else
  {
    digitalWrite(LED1, LOW);
  }
  
  // D2, 22.5-67.5
  if (w > 22.5 &&  w < 67.5)
  {
    digitalWrite(LED2, HIGH);
  }
  else
  {
    digitalWrite(LED2, LOW);
  } 
  
  // D3, 67.5-112.5
  if (w > 67.5 &&  w < 112.5)
  {
    digitalWrite(LED3, HIGH);
  }
  else
  {
    digitalWrite(LED3, LOW);
  }
 
 // D4, 112.5-157.5
  if (w > 112.5 &&  w < 157.5)
  {
    digitalWrite(LED4, HIGH);
  }
  else
  {
    digitalWrite(LED4, LOW);
  }
  
  // D5, 157.5-202.5
  if (w > 157.5 &&  w < 202.5)
  {
    digitalWrite(LED5, HIGH);
  }
  else
  {
    digitalWrite(LED5, LOW);
  }

  // D6, 202.5-247.5
  if (w > 202.5 &&  w < 247.5)
  {
    digitalWrite(LED6, HIGH);
  }
  else
  {
    digitalWrite(LED6, LOW);
  }

  // D7, 247.5-292.5
  if (w > 247.5 &&  w < 292.5)
  {
    digitalWrite(LED7, HIGH);
  }
  else
  {
    digitalWrite(LED7, LOW);
  }

  // D8, 292.5-337.5
  if (w > 292.5 &&  w < 337.5)
  {
    digitalWrite(LED8, HIGH);
  }
  else
  {
    digitalWrite(LED8, LOW);
  }    
  
  // Ausgabe Winkelgrad
  Serial.print("Winkel: ");
  Serial.println(w);

  delay(100);
   
}
