// 
// LED als Lichtsensor
// Datei: buch4_kap7_led_lichtsensor.ino
// Quelle: http://www.thebox.myzen.co.uk/Workshop/LED_Sensing.html


/* LED Sensors - Mike Cook - December 2008
 *  
 * ----------------- 
 * 
 
#######################################################################

HARDWARE NOTE: Anodes driven direct from pins 7, 6, 5 .....
               Cathodes through a resistor (220R) to analogue inputs A0, A1, ....
               Analogue inputs can be reprogrammed to be digital outputs

#######################################################################
*/


// LED als Sensor
// Nach einer Idee von Mike Cook
// http://www.thebox.myzen.co.uk/Workshop/LED_Sensing.html

byte anodePin =  7;    // Pin D7
byte cathodePin = 14;  // Pin A0
int result;

void setup() { 
  // Disable Pull-up-Widerstand
  _SFR_IO8(0x35) |= 0x10;
  digitalWrite(anodePin,LOW);
  pinMode(anodePin,OUTPUT);
  pinMode(cathodePin,INPUT);

  //Serielle Kommunikation
  Serial.begin(38400);          
}

void loop () {
  // Schritt 1
  // LED Ein
  digitalWrite(anodePin,HIGH);
  pinMode(cathodePin,OUTPUT);
  digitalWrite(cathodePin,LOW);

  // Schritt 2
  // LED laden, Kathode = HIGH, Anode = LOW
  digitalWrite(cathodePin,HIGH); 
  digitalWrite(anodePin,LOW);    
  
  // Schritt 3
  // LED entladen und Analogwert lesen
  // Kathode als Analog Input
  pinMode(cathodePin,INPUT);
  // Wert als Referenz
  result = analogRead(0);
  // LED Entladungszeit
  delay(40);  
 
  // Sensor lesen nach Entladung
  // Veränderung ermitteln
  result = resultat - analogRead(0);
  pinMode(cathodePin,OUTPUT);
  digitalWrite(cathodePin,LOW);
  // Ausgabe Analogwert
  Serial.print(result,DEC);
  Serial.print(" ");
  Serial.println(" ");
}
