//
// Serielles EEPROM 24LC64 lesen und schreiben
// Datei: buch4_kap8_eeprom_24lc64.ino


#include <Wire.h> 
#define eeprom 0x50  // Adresse festlegen

void setup(void)
{
  Wire.begin();
  Serial.begin(9600);
  unsigned int address = 0;  // Startadresse
  Serial.println("10 Bytes Daten schreiben");
  for(address = 0; address<10; address++) 
  {
    // Daten ausgeben
    Serial.print("Write: ");
    Serial.println(address);
    // Adresswert als Daten in EEPROM schreiben
    writeEEPROM(eeprom, address, address);
  }

  // Ausgabe Daten
  for(address = 0; address<10; address++) {
    Serial.print(readEEPROM(eeprom, address), HEX);
    Serial.print(", ");
  }
}

void loop()
{
}

void writeEEPROM(int deviceaddress, unsigned int eeaddress, byte data )
{
  Wire.beginTransmission(deviceaddress);
  Wire.write((int)(eeaddress >> 8));   // MSB
  Wire.write((int)(eeaddress & 0xFF)); // LSB
  Wire.write(data);
  Wire.endTransmission();
}

byte readEEPROM(int deviceaddress, unsigned int eeaddress )
{
  byte rdata = 0xFF;
  Wire.beginTransmission(deviceaddress);
  Wire.write((int)(eeaddress >> 8));   // MSB
  Wire.write((int)(eeaddress & 0xFF)); // LSB
  Wire.endTransmission();
  Wire.requestFrom(deviceaddress,1);
  if (Wire.available()) rdata = Wire.read();
  return rdata;
}
