// Beispiel für SoftSerial
// Datei: buch4_kap9_example_softserial.ino
// Datum: 19.01.19

#include <SoftwareSerial.h>

// Serielles GPS-Modul an Pin 2 und Pin 3 (Rx, Tx)
SoftwareSerial GPS(2, 3);
// Serielles LC-Display an Pin 4 und Pin 5 (Rx, Tx)
SoftwareSerial LCD(4, 5);

void setup ()
{
  // Schnittstelle LCD starten
  LCD.begin(9600);
  // Schnittstelle GPS starten
  GPS.begin(9600);
}

void loop ()
{
  // falls Daten von GPS vorhanden sind
  if (GPS.available())
  {
    // GPS Daten einlesen
    // und Daten auf auf LCD
    LCD.write(GPS.read());
  }
 }


/*
// Beispiel Original

// software serial #1: TX = digital pin 2, RX = digital pin 3
SoftwareSerial portOne(2, 3);

// software serial #2: TX = digital pin 4, RX = digital pin 5
SoftwareSerial portTwo(4, 5);

void setup()
{
  // Start the hardware serial port
  Serial.begin(9600);

  // Start each software serial port
  portOne.begin(9600);
  portTwo.begin(9600);
}

void loop()
{
  // By default, the last intialized port is listening.
  // when you want to listen on a port, explicitly select it:
  portOne.listen();
  Serial.println("Data from port one:");
  // while there is data coming in, read it
  // and send to the hardware serial port:
  while (portOne.available() > 0) {
    char inByte = portOne.read();
    Serial.write(inByte);
  }

  // blank line to separate data from the two ports:
  Serial.println();

  // Now listen on the second port
  portTwo.listen();
  // while there is data coming in, read it
  // and send to the hardware serial port:
  Serial.println("Data from port two:");
  while (portTwo.available() > 0) {
    char inByte = portTwo.read();
    Serial.write(inByte);
  }

  // blank line to separate data from the two ports:
  Serial.println();
}

*/




