//
// RFM12B Empfänger
// Datei: buch4_kap4_5_rfm12b_receiver_payload.ino

#include <JeeLib.h>

#define NodeID 2
#define NetID 100
#define band RF12_433MHZ
//#define freq RF12_868MHZ

typedef struct {
  int temp;
} Payload;

Payload rx;

// ID des Senders
int nodeID;

int temp;
float tempC;

void setup ()
{
  // Serielle Schnittstelle
  Serial.begin(57600);
  Serial.print("Start RF");
  // Initialisierung RF
  rf12_initialize(NodeID, band, NetID);
}


void loop ()
{
  if (rf12_recvDone() && rf12_crc == 0 && (rf12_hdr & RF12_HDR_CTL) == 0)
  {
    // NodeID abfragen
    nodeID = rf12_hdr & 0x1F;
    rx = *(Payload*) rf12_data;
    temp = rx.temp;
    // Umwandlung in Temperatur
    tempC=(5.0 * temp * 100.0)/1024.0;
    // Datenausgabe
    Serial.println("Daten empfangen:");
    Serial.print("Sender: ");
    Serial.println(nodeID);
    Serial.print("Wert: ");
    Serial.println(tempC);
    Serial.println("--------------------");
 }
}
